;*******************************************************************************
;*      
;* (  RC-5)
;*
;**********************************************
.include "TN13DEF.inc"
;**********************************************
; 
;.equ rccal   =0x80    ;   RC 

;.equ systIR  =29+192   ;   (+ )
;.equ commIR1 =1*4      ; 
;.equ commIR2 =2*4      ;   (   )

;.equ UbL     =240      ;   Ubat.
;   
.def s       = r3
.def tempL   = r4
.def tempcom= r5    ;    
.def command= r6    ;        ()
.def rADCH  = r7    ;   

.def temp   = r16    ; 
.def cntIZ  = r17    ;     
.def cntBIT = r18    ;   
.def system = r19   ;      
.def rgf    = r20    ;  
.def rADCL  = r21    ;   

.def systIR  = r22    ;  
.def commIR1 =  r8    ;    ON/UP
.def commIR2 =  r9    ;    OFF/DOWN

;.def cntBYTE= r19    ;   
;   
.equ e125ms  =0       ;  125 ms.
.equ p250ms  =1      ;    250 .
.equ signTWO  =2      ;      Ub

.equ pBIT10  =3      ;   1   0
.equ pBIT11  =4      ;   1   1

;**********************************************
;   EEPROM 
.ESEG
.org 0x00
   .DB  29     ;   
   .DB   1     ;    ON/UP
   .DB   2     ;    OFF/DOWN

;**********************************************
;  Reset and interrupt vectors
;
.cseg
.org $00
 rjmp RESET           ; $000 Reset handler
reti; rjmp EXT_INT0   ; $001 IRQ0 handler
 rjmp PCINT           ; $002 Pin change handler
 rjmp TIM0_OVF        ; $003 Timer0 overflow handler
reti;rjmp EE_RDY      ; $004 EEPROM Ready handler
reti;rjmp ANA_COMP    ; $005 Analog Comparator handler
reti;rjmp TIM0_COMPA  ; Timer0 CompareA Handler
reti;rjmp TIM0_COMPB  ; Timer0 CompareB Handler
reti;rjmp WATCHDOG ; Watchdog Interrupt Handler
 rjmp ADC_ ; $009 ADC Conversion Handler



;********************************************************************
;*       

 PCINT:
 ;  in s,sreg
    push temp
    ldi temp,0
    out GIMSK,temp      ;   
 ;  out sreg,s
    pop temp
  reti

;********************************************************************
;* "TIM1_OVF" - Timer/counter 1  
;  ,   

TIM0_OVF:
   in s,sreg
   dec cntIZ
   out sreg,s
 reti
;***********************************************
;********************************************************************
;* "ADC Complete Handler
;      
ADC_:
    in rADCL,ADCL          ; 
    in rADCH,ADCH          ;  
  reti

;********************************************************************

;***********************************************
;  Reset handler
;
 reset:

     ldi temp,RAMEND
	 out SPL,temp          ;  


     ldi temp,0b00011011    ;
     out DDRB,temp          ;   
     ldi temp,0b00000000    ;
     out PORTB,temp         ;      

     sbi ACSR,ACD           ; .  

     ldi temp,1<<PCINT2
	 out PCMSK,temp

   begin:
	  ldi temp,0x18
	  out OCR0B,temp       ;  =(27,777-6,94) .
	  ldi temp,0x21
	  out OCR0A,temp       ; + 6,94 .
	  ldi	temp,1<<TOIE0  ;    	
	  out	TIMSK0,temp    ;  T0
	
	  clr rgf             ;   

	  sbic EECR,EEPE           ;   EEPROM  
      rjmp PC-1                ;  
         ldi temp,$00           ; 
         out EEARL,temp         ;   EEPROM
         sbi EECR,EERE          ;  
         in systIR,EEDR         ;   
         subi systIR,-192       ;   

		 inc temp               ; 
         out EEARL,temp         ;   EEPROM
         sbi EECR,EERE          ;  
         in commIR1,EEDR        ;     ON/UP
         lsl commIR1
         lsl commIR1            ;    

		 inc temp               ; 
         out EEARL,temp         ;   EEPROM
         sbi EECR,EERE          ;  
         in commIR2,EEDR        ;     OFF/DOWN
         lsl commIR2
         lsl commIR2            ;    
		          	
;***********************************************
;  
 main:
   cli
   ldi temp,(1<<SM1)+(1<<SE)     ;    "POWER DOWN"
   out MCUCR,temp
   ldi temp,1<<PCIE
   out GIMSK,temp      ;      
   sei
   sleep
      

     ldi temp,60          ;   30 .   
    delay30ms:
     clr tempL      ;  (  0,16 .)
      delay016ms:
       dec tempL
       brne delay016ms  ;
       dec temp
      brne delay30ms

   sbic PINB,PB2    ;      
   rjmp main        ;      

     cli            ;     
      ldi temp,(1<<SM0)+(1<<SE)     ;     
      out MCUCR,temp
      ldi temp,(1<<ADEN)|(1<<ADPS2)|(1<<ADIE)
      out ADCSRA,temp     ;  75 .  ,   
      ldi temp,1<<MUX0
      out ADMUX,temp               ; U = Vcc    1   
      sei
      sleep

      mov tempcom,commIR1      ;     ON/UP
	  cpi rADCL,35             ;    >35
	  brsh trfBit              ;   (  ON/UP) 
      mov tempcom,commIR2      ;     OFF/DOWN
		

   trfBit:            ;     
     ldi cntBIT,14           ;   14 
     mov system,systIR
     mov command,tempcom
	
   trBit:             ;    
    ldi cntIZ,32             ;    
    lsl command              ; 
    rol system               ;   
    brcs trBit1              ;    1 -   

   trBit0:          ;     - "0"
     ldi temp,(1<<CS00)|(1<<WGM02)                          ; Timer/Counter 1 clocked at CK
	 out TCCR0B,temp                                        ;   FASTPWM  OCR0A
	 ldi temp,(1<<COM0B1)|(1<<COM0B0)|(1<<WGM01)|(1<<WGM00) ;  .  
     out TCCR0A,temp 
	 sbi PORTB,0    ;   

    ctr01:          ;    
     cpi cntIZ,0    ;   
     brne ctr01     ;   
	 cbi PORTB,0    ;   
     ldi cntIZ,32   ;    
     ldi temp,(1<<WGM01)|(1<<WGM00)          
	 out TCCR0A,temp                         ;   OC0B   
    ctr02:          ;    
     cpi cntIZ,0    ;   
     brne ctr02     ;   
     dec cntBIT     ; -1
     brne trBit     ;     14  -  
    rjmp delay89ms  ;    


   trBit1:          ;    - "1"
     ldi temp,(1<<CS00)|(1<<WGM02)                          ; Timer/Counter 1 clocked at CK
	 out TCCR0B,temp                                        ;   FASTPWM  OCR0A
	 ldi temp,(1<<WGM01)|(1<<WGM00) 
     out TCCR0A,temp                                        ;   OC0B   

    ctr11:          ;    
     cpi cntIZ,0    ;   
     brne ctr11     ;   
     ldi cntIZ,32             ;    
	 ldi temp,(1<<COM0B1)|(1<<COM0B0)|(1<<WGM01)|(1<<WGM00) ;  .  
     out TCCR0A,temp 
	 sbi PORTB,0    ;   
    ctr12:          ;    
     cpi cntIZ,0    ;   
     brne ctr12     ;   
     cbi PORTB,0    ;   
     dec cntBIT     ; -1
     brne trBit     ;     14  -  

   delay89ms:
	 ldi temp,(1<<WGM01)|(1<<WGM00) 
     out TCCR0A,temp                                        ;   OC0B   
	  ldi cntBIT,50        ;   50   1,778 ms.
	 delay1788mks:
	   ldi cntIZ,64
	  dlimp:
      cpi cntIZ,0        ;   
      brne dlimp         ;   
      dec cntBIT         ; -1
      brne delay1788mks  ;     50  -  
	
	
   oprkeypr:      ; ,    
      clr temp      
	  out TCCR0A,temp     ;      
	  out TCCR0B,temp     ; Timer0 
      sbis PINB,PB2       ;   
	  rjmp trfBit         ;  
	  rjmp main           ;   

	






